﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

namespace AgentTabSl
{
    public partial class Group : UserControl
    {
        public Group()
        {
            InitializeComponent();
        }

        public event EventHandler<EventArgs> SignedInChanged;

        public Guid Id { get; private set; }

        public string AgentGroupName
        {
            get
            {
                return GroupName.Text;
            }
            set
            {
                GroupName.Text = value;
            }
        }

        public bool CanSignIn
        {
            get
            {
                return SignedIn.IsEnabled;
            }
            set
            {
                SignedIn.IsEnabled = value;
            }
        }

        public bool IsSignedIn
        {
            get
            {
                return SignedIn.IsChecked.Value;
            }
            set
            {
                SignedIn.IsChecked = value;
            }
        }

        internal static Group Create(Guid id, bool formal, bool signedIn, string name, int numAgents)
        {
            Group g = new Group();

            g.Id = id;
            g.GroupName.Text = name;
            g.SignedIn.IsEnabled = formal;
            g.SignedIn.IsChecked = signedIn;

            g.AgentCount.Text = numAgents.ToString();

            if (formal)
            {
                g.Back.Fill = Application.Current.Resources["BrushFormal"] as System.Windows.Media.Brush;
            }
            else
            {
                g.Back.Fill = Application.Current.Resources["BrushInformal"] as System.Windows.Media.Brush;
            }

            return g;
        }

        private void OnSignedInChanged(object sender, RoutedEventArgs e)
        {
            if (null != SignedInChanged)
            {
                SignedInChanged(this, e);
            }
        }
    }
}
